<?php

namespace Drupal\pagecss\Form;

use Drupal\Core\Entity\EntityForm;
use Drupal\Core\Entity\EntityTypeManager;
use Drupal\Core\Form\FormStateInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Component\Render\FormattableMarkup;
use Drupal\Core\Url;

/**
 * Form handler for the Example add and edit forms.
 */
class ListForm extends ConfigFormBase
{
  
    /**  
     * {@inheritdoc}  
     */  
    protected function getEditableConfigNames()
    {  
        return [  
        'pagecss.adminsettings',  
        ];
    }  

    /**  
     * {@inheritdoc}  
     */  
    public function getFormId()
    {  
        return 'pagecss_overview_form';  
    } 
  
    /**  
     * {@inheritdoc}  
     */  
    public function buildForm(array $form, FormStateInterface $form_state)
    {  
        $config = $this->config('pagecss.adminsettings'); 
        //1. get master list
        $masterList = $this->config('pagecss.adminsettings')  
            ->get('urlMasterList');
        
        /* echo '123<pre>'; print_r($masterList); exit; */
        /* echo '123<pre>'; print_r($this->config('pagecss.adminsettings')->get('/test')); exit; */

        $header = [
        /* 'ID' => t('ID'), */
        'Route' => t('route'),
        'Style' => t('style'),
        'Action' => t('actions'),
        '' => t(' ')
        ];
    
        // Initialize an empty array
        $output = [];
        // Next, loop through the $results array
        foreach ($masterList as $key => $item) {
            $output[$key] = [
            /* 'ID' => $key, */
            'Route' => $item,
            'Style' => $this->config('pagecss.adminsettings')->get($item),
            'Action' => [
            new FormattableMarkup(
                '<a href=":link">@name</a>',
                [':link' => '/admin/config/pagecss/' . $key . '/edit', '@name' => 'Edit']
            ),
            new FormattableMarkup(
                '<a href=":link">@name</a>',
                [':link' => '/admin/config/pagecss/' . $key . '/delete', '@name' => 'Delete']
            )
            ]
            ];
        }
    
        /* $form['message'] = [
        '#type' => 'item',
        '#markup' => $this->t('To add new configuration use the button below'),
        '#weight' => 0,
        ]; */
    
        $form['addnew'] = [
        /* '#type' => 'link',
        '#value' => t('Add new configuration'),
        '#name' => t('addnewpagecss'), */
        '#title' => $this->t('Add new configuration'),
        '#type' => 'link',
        '#url' => \Drupal\Core\Url::fromRoute('pagecss.add_configuration'),
        '#weight' => 1
        ];
    
        $form['message'] = [
        '#type' => 'item',
        '#markup' => $this->t('Presently active PageCSS rules'),
        '#weight' => 2,
        ];
    
        $form['table'] = [
        '#type' => 'tableselect',
        '#weight' => 5,
        '#header' => $header,
        '#options' => $output,
        '#empty' => t('No configurations found'),
        ];

        return parent::buildForm($form, $form_state);  
    } 
  
    /**  
     * {@inheritdoc}  
     */  
    public function submitForm(array &$form, FormStateInterface $form_state)
    {  
        parent::submitForm($form, $form_state);  
    
        /* echo '<pre>'; print_r($form_state); exit; */
    
        /* get master url list */
        /* $masterList = $this->config('pagecss.adminsettings')  
        ->get('urlMasterList');
        
        $thisUrl = $form_state->getValue('url');
        trim($thisUrl, " ");
        
        if(!empty($masterList)) {
        $masterList.push($thisUrl);
        } else {
        $masterList = [];
        $masterList.push($thisUrl);
        }
    
        $this->config('pagecss.adminsettings')  
        ->set('urlMasterList', $masterList)  
        ->set($thisUrl, $form_state->getValue('css_style'))
        ->save(); */

        /* $this->config('pagecss.adminsettings')  
        ->set('url', $form_state->getValue('url'))  
        ->save();  */ 
    }
}
